#include <stdio.h>
#include <stdlib.h>

#include "utils/buffer.h"

#include "lexer.h"

int
main (int argc, char **argv)
{
	if (argc < 2)
		{
			fprintf (stderr, "usage: %s [filename]\n", argv[0]);
			return EXIT_FAILURE;
		}

	struct buffer code = buffer_create ();
	if (!buffer_read (argv[1], &code))
		return EXIT_FAILURE;

	struct lexer lexer = lexer_create ();
	lexer_set_source (&code, &lexer);
	lexer_lex (&lexer);
	lexer_print (&lexer);

	lexer_free (&lexer);
	buffer_free (&code);

	return EXIT_SUCCESS;
}
